local LFtimerActive = false;
local LFtimerStart = 0;
local LF_SWtimerActive = false;
local LF_SWtimerStart = 0;
local LF_loaded = false
local LF_addManagRegistered = false

function Loot_OnLoad()
	if ( LF_loaded == true ) then
		return;
	end
	
	LF_playerName = UnitName("player");
	if ( LF_playerName == nil or LF_playerName == "" ) then
		return;
	end
	local lootFilterDefaultSettings = {
			["ENABLE"] 					= true,
			["showLoot"] 				= true,
			["showJunk"] 				= true,
			["useWildcards"] 			= true,
			["EnableSweepGarbage"]		= true,
			["sweepGarbageOnLoot"]		= false,
			["autoSweepGarbage"]		= false,
			["enableFilterOnPickup"]	= false,
			["showGarbageLog"]			= true,
			["chatToUse"]				= 1,
			["fastLooting"]				= true,
			["disKey"]					= 1
	};
    if (type(lootFilterConf) ~= "table") then
		lootFilterConf = {}
		lootFilterConf[LF_playerName] = lootFilterDefaultSettings;
	else	
		if (type(lootFilterConf["ENABLE"]) ~= "nil") then
			--copy old settings
			ChatFrame1:AddMessage("palxer"..LF_playerName)
			local oldSettings = lootFilterConf
			lootFilterConf = {}
			lootFilterConf[LF_playerName] = oldSettings
			l_log("LootFilter - old settings found - moving them into new system");
		elseif type(lootFilterConf[LF_playerName]) ~= "table" then
			lootFilterConf[LF_playerName] = lootFilterDefaultSettings;
		end
		
			for k,v in pairs(lootFilterDefaultSettings) do
				if (lootFilterConf[LF_playerName][k] == nil) then
					lootFilterConf[playerName][k] = v;
				end;
			end;
	end;
	
	--no blacklist at all
    if (type(lootFilterBlacklist) ~= "table") then
		lootFilterBlacklist = {};
	else
		--copy old settings
		for k,v in pairs(lootFilterBlacklist) do
			if (type(k) == 'number') then
				--there are old settings
				l_log("LootFilter - old blacklist found - moving it into new system");
				local oldSett = lootFilterBlacklist
				lootFilterBlacklist = {}
				lootFilterBlacklist[LF_playerName] = oldSett
				break
			end;
		end;	
	end
	-- no blacklist for current player
	if (type(lootFilterBlacklist[LF_playerName]) ~= "table") then
		lootFilterBlacklist[LF_playerName] = {};
	end;
	
	--registerAddonManager()
	--if not AddonManager then
		l_log("LootFilter v 0.65 loaded");	
	--end	
	
	LF_loaded = true 

end;

function registerAddonManager()
    if AddonManager then
        local addon = {
            name = "LootFilter", 
            description = "Throws away items you don't need", 
            icon = "Interface/BagFrame/garbagecan-normal.tga", 
            category = "Inventory",
            configFrame = LootFilterConfFrame, 
            slashCommands = "/lf", 
            miniButton = LootFilterMiniButton,
            version = "v0.65",
            author = "Onotole",
        }
        if AddonManager.RegisterAddonTable then
            AddonManager.RegisterAddonTable(addon)
        else
            AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category, 
                addon.configFrame, addon.slashCommands, addon.miniButton, addon.onClickScript)
        end
    end	
end

function LootFilterFrame_OnEvent(this, event, arg1, arg2)
	if ( event == "VARIABLES_LOADED" ) then
        -- If the user does a /script ReloadUI() only this event will be called.
		if ( LF_loaded ~= true ) then
			Loot_OnLoad();
		end
		return;
	end
	if ( event == "UNIT_PORTRAIT_UPDATE" and arg1 == "player" ) then
		if ( LF_loaded ~= true ) then
			Loot_OnLoad();
		end
		return;
	end
end




function  LF_delayedClose()
	LFtimerStart = GetTickCount();
	LFtimerActive = true;
end;

function  LF_delayedSweep()
	LF_SWtimerStart = GetTickCount();
	LF_SWtimerActive = true;
end;

function LF_Update()
	if (LFtimerActive == true) then
		local timerHit = GetTickCount()-LFtimerStart;
		if (timerHit > 200) then
			--l_log("timer hit: ");
			-- ok, the timer worked now execute the callback
			LFtimerActive = false;
			BootyFrame:Hide();
		end;	
	end	
	if (LF_SWtimerActive == true) then
		local timerHit = GetTickCount()-LF_SWtimerStart;
		if (timerHit > 700) then
			-- ok, the timer worked now execute the callback
			LF_SWtimerActive = false;
			sweepGarbage();
		end;	
	end
end;

function LootingAction()
	if lootFilterConf[LF_playerName]["disKey"] == 1 then 
		if IsShiftKeyDown() then return end;
	elseif lootFilterConf[LF_playerName]["disKey"] == 2 then
		if IsAltKeyDown() then return end;
	else
		if IsCtrlKeyDown() then return end;
	end;	
	if lootFilterConf[LF_playerName]["ENABLE"] == false then return end;
	--  filtering on pickup
	--if lootFilterConf[LF_playerName]["enableFilterOnPickup"] then
		lootFilter();
	--end	
	--  sweeping garbage	
	if lootFilterConf[LF_playerName]["sweepGarbageOnLoot"] then
		LF_delayedSweep();
		--sweepGarbage();
	end	
end;

function lootFilter()
    local index = BootyFrame.page * MAX_BOOTYFRAME_ITEMS;
	local junkInLoot = false;
    local maxNum = GetBootyNumItems();
    local texture, name, count, quality;
    for i = 1, MAX_BOOTYFRAME_ITEMS do
        if ( i + index <= maxNum ) then
            texture, name, count, quality = GetBootyItemInfo(i + index);
            if ( texture and name ) then
				blacklisted = false;
				if lootFilterConf[LF_playerName]["enableFilterOnPickup"] then
					for k,v in pairs(lootFilterBlacklist[LF_playerName]) do 
						local itype, idata, iname = ParseHyperlink( v );
						if (iname) then
							-- parse a hyperlink	
							v = iname
						end	
						v = string.gsub(v,"-","%%-")
						if  (lootFilterConf[LF_playerName]["useWildcards"] and type(string.find(name, "^"..string.gsub(v,"*",".*").."$")) ~= "nil")or (lootFilterConf[LF_playerName]["useWildcards"] == false and v == name)	then
						--/eval string.find("Recipe -Enhanced shit", "^"..string.gsub("Recipe -Enhanced*","\*",".*").."$")
							blacklisted = true;
							junkInLoot = true;
							if  lootFilterConf[LF_playerName]["showJunk"] then  
								link = GetBootyItemLink(i + index);
								l_log("Blacklisted item not picked up: "..link);
							end;
							BootyFrame.takeTime = nil;
							break;
						end;
					end;
				end
				if blacklisted ==  false then
					link = GetBootyItemLink(i + index);
					ClickBootyItem(i + index)
					if  lootFilterConf[LF_playerName]["showLoot"] then
						if count > 1 then
							l_log("Loot: "..count.." "..link); 
						else 	
							l_log("Loot: "..link); 
						end;	
					end;
				end;
                --index = i + index;
            else
                -- No texture and name, do something
            end
        else	
				--we have som juk in loot, so it wont close, lets do it ourself
				-- call a closeBooty function in 100ms
				LF_delayedClose();
        end
    end
end;




function l_log(text,color)
	if (color == nil) then color = "eedd99"; end;
	--local baseMsg = "[|ccf6000f ".."L".."|ccdf00d5 ".."o".."|cc58a950 ".."o".."|ccecdc2e ".."t".."|r] >";
	local baseMsg = "[Loot]>";
	if lootFilterConf[LF_playerName]["chatToUse"] == 1 then ChatFrame1:AddMessage(baseMsg .. "|cc".. color .. " " .. text .. "|r") end
	if lootFilterConf[LF_playerName]["chatToUse"] == 2 then ChatFrame2:AddMessage(baseMsg .. "|cc".. color .. " " .. text .. "|r") end
	if lootFilterConf[LF_playerName]["chatToUse"] == 3 then ChatFrame3:AddMessage(baseMsg .. "|cc".. color .. " " .. text .. "|r") end
	if lootFilterConf[LF_playerName]["chatToUse"] == 4 then ChatFrame4:AddMessage(baseMsg .. "|cc".. color .. " " .. text .. "|r") end
end;


function LootFilterConfig(ebox, variable)
	if (type(variable) == "nil" or variable == "") then
		LootFilterConfFrame:Show();
		--Loot_usage();
	else
		local arg = string.upper(variable);
		if arg == "ON" then
			lootFilterConf[LF_playerName]['ENABLE'] = true;
			l_log("LootFilter enabled");
		elseif 	arg == "OFF" then
			lootFilterConf[LF_playerName]['ENABLE'] = false;
			l_log("LootFilter disabled");
		elseif 	arg == "LIST" then
			l_log("Blacklisted items:");
			l_log("---------------------------");
			for k,v in pairs(lootFilterBlacklist[LF_playerName]) do 
				l_log(v);
			end;	
			l_log("---------------------------");
		elseif string.find (arg, "ADD") then
			if type(string.find(variable, "add (.+)")) ~= "nil" then
				local l_start, l_end, l_item = string.find(variable, "add (.+)")
				local l_item = trim(l_item);
				if l_item ~= "" then
					table.insert(lootFilterBlacklist[LF_playerName], l_item);
					l_log(l_item .. " added into blacklist");
				else 	
					l_log("Use /lootfilter add item_name to add an item into blacklist, i.e. /lootfilter add Damaged Tool");
				end;	
			else 
				l_log("Use /lootfilter add item_name to add an item into blacklist, i.e. /lootfilter add Damaged Tool");
			end;
		elseif string.find (arg, "REMOVE") then
			local removeFlag = false;
			if type(string.find(variable, "remove (.*)")) ~= "nil" then
				l_start, l_end, l_item = string.find(variable, "remove (.*)")
				for k,v in pairs(lootFilterBlacklist[LF_playerName]) do 
						local itype, idata, iname = ParseHyperlink( v );
						if (iname) then
							-- parse a hyperlink	
							v = iname
						end					
					if v == l_item then
						table.remove(lootFilterBlacklist[LF_playerName],k);
						removeFlag = true;
						break;
					end;	
				end;		
				if removeFlag then
					l_log(l_item .. " removed from blacklist");
				else 
					l_log(l_item .. " was not found");
				end;	
			else 
				l_log("Use /lootfilter remove item_name to remove an item from blacklist, i.e. /lootfilter remove Damaged Tool");
			end;			
		elseif arg == "ADD" then
			l_log("add:");
		else 
			Loot_usage();
		end;
	end;
end;

function Loot_usage()
	if lootFilterConf[LF_playerName]["ENABLE"] then
		l_log("Lootfilter is currently on");
	else 
		l_log("Lootfilter is currently off");
	end;	
end;

function sweepGarbage()
	if lootFilterConf[LF_playerName]["ENABLE"] == false then return end;
	if lootFilterConf[LF_playerName]["EnableSweepGarbage"] == false then return end;

	-- global
	garbageQuant = 0;
	-- loop over all inventory items and add the blacklisted into garbage bin
    local bagItemCount, bagTotalSlots = GetBagCount();
    for i = 1,bagTotalSlots do
		local itemID, itemIconFile, itemName, itemCount = GetBagItemInfo(i)
		if ( itemIconFile and itemName ) then
			RemoveGarbageItem(itemID);
			blacklisted = false;
			for k,v in pairs(lootFilterBlacklist[LF_playerName]) do 
				local itype, idata, iname = ParseHyperlink( v );
				if (iname) then
					-- parse a hyperlink	
					v = iname
				end				
				v = string.gsub(v,"-","%%-")
					if  (lootFilterConf[LF_playerName]["useWildcards"] and type(string.find(itemName, "^"..string.gsub(v,"*",".*").."$")) ~= "nil")or (lootFilterConf[LF_playerName]["useWildcards"] == false and v == itemName)	then
					garbageQuant = garbageQuant + 1 -- is there i++ in Lua?
					blacklisted = true;
					if  lootFilterConf[LF_playerName]["showGarbageLog"] == true then  
						local itemLink = GetBagItemLink(itemID);
						l_log("Item moved to garbage: "..itemCount.." "..itemLink);
					end;
					-- todo move to garbage
						InsertGarbageItem(itemID);
					break;
				end;
			end;
		else
                -- No texture and name, do something
		end	
	end;

	if garbageQuant > 0 then
		--some garbage found, lets handle this
		if lootFilterConf[LF_playerName]["autoSweepGarbage"] == false then
			GarbageFrame:Show();
		else
			if garbageQuant > 3 then
				--to much stuff to throw away - maybe an error??
				StaticPopupDialogs["DELETE_TOO_MUCH_GARBAGE"]["text"] = "You are going to delete "..garbageQuant.." items, are you sure?"
				StaticPopup_Show("DELETE_TOO_MUCH_GARBAGE");
			else	
				if  lootFilterConf[LF_playerName]["showGarbageLog"] then  
					l_log(garbageQuant .. " garbage items were thrown away");
				end	
				--todo clickongarbage
				DeleteGarbageItems();
			end
		end;	
	end;
end;

SLASH_lootfilter1 = "/lootfilter";
SLASH_lootfilter2 = "/lf";
SlashCmdList["lootfilter"] = LootFilterConfig;
SLASH_sweepGarbage1 = "/sweepGarbage";
SlashCmdList["sweepGarbage"] = sweepGarbage;


function trim (s)
      return (string.gsub(s, "^%s*(.-)%s*$", "%1"))
end

StaticPopupDialogs["DELETE_TOO_MUCH_GARBAGE"] = {
	text = "",
	button1 = TEXT("YES"),
	button2 = TEXT("NO"),
	OnAccept = function()
		DeleteGarbageItems();
		l_log(garbageQuant  .. " garbage items were thrown away");
	end,
	OnCancel = function()
		CloseGarbageItems();
		l_log("Garbage items were not thrown away");
	end,	
	timeout = 0,
	whileDead = 1,
	exclusive = 1,
	showAlert = 1,
	hideOnEscape = 1
};